//+------------------------------------------------------------------+
//|                                                   CtradeTest.mq5 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.002"
#include <Trade\PositionInfo.mqh>
#include <Trade\Trade.mqh>
#include <Trade\SymbolInfo.mqh>  
//---
input string first   ="EURUSD";
input string second  ="GBPUSD";
//---
ulong          m_magic=15489;                // magic number

CPositionInfo  m_position;                   // trade position object
CTrade         m_trade;                      // trading object
CSymbolInfo    m_symbol_1;                   // symbol info object for symbol "first"
CSymbolInfo    m_symbol_2;                   // symbol info object for symbol "second"
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   m_symbol_1.Name(first);
   m_symbol_1.Refresh();
   m_symbol_2.Name(second);
   m_symbol_2.Refresh();

   RefreshRates();
   m_trade.SetExpertMagicNumber(m_magic);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   if(!RefreshRates())
      return;

//--- count  positions
   int total=0;
   for(int i=PositionsTotal()-1;i>=0;i--) // returns the number of open positions
      if(m_position.SelectByIndex(i))
         if((m_position.Symbol()==m_symbol_1.Name() || m_position.Symbol()==m_symbol_2.Name()) && 
            m_position.Magic()==m_magic)
            total++;
   if(total==0)
     {
      m_trade.Buy(0.01,m_symbol_1.Name());
      m_trade.Sell(0.01,m_symbol_2.Name());
     }

   double bid_1=m_symbol_1.Bid();
   double bid_2=m_symbol_2.Bid();
   Comment(first," Bid: ",DoubleToString(bid_1,m_symbol_1.Digits()),"\n",
           second," Bid: ",DoubleToString(bid_2,m_symbol_2.Digits()));
  }
//+------------------------------------------------------------------+
//| Refreshes the symbol quotes data                                 |
//+------------------------------------------------------------------+
bool RefreshRates()
  {
//--- refresh rates
   if(!m_symbol_1.RefreshRates() || !m_symbol_2.RefreshRates())
      return(false);
//--- protection against the return value of "zero"
   if(m_symbol_1.Ask()==0 || m_symbol_1.Bid()==0 || m_symbol_2.Ask()==0 || m_symbol_2.Bid()==0)
      return(false);
//---
   return(true);
  }
//+------------------------------------------------------------------+
